=== modified file 'Makefile'
--- Makefile	2010-08-16 19:00:59 +0000
+++ Makefile	2009-05-23 05:59:52 +0000
@@ -9,19 +9,14 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
-LINK_FORTIFY_LD=-z relro -z now
-LINK_FORTIFY=
-ifndef BROKEN_PIE
-FORTIFY += -fPIE
-LINK_FORTIFY_LD += -fPIE
-LINK_FORTIFY += -pie
-endif
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
+LINK_FORTIFY_LD=-z relro -fPIE
+LINK_FORTIFY=-pie
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.14
+version=1.0.11
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -207,17 +202,6 @@
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
-	@echo "###################################################################"
-	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setuid: Operation not permitted             #"
-	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client: setuid: Operation not permitted             #"
-	@echo "#                     seteuid: Operation not permitted            #"
-	@echo "#                     klogctl: Operation not permitted            #"
-	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
@@ -230,13 +214,6 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE errors about \"No permission to bind to    #"
-	@echo "# interface\" or \"Could not open file u'/var/run/mandos.pid'\" -  #"
-	@echo "# they are harmless and are caused by the server not running as #"
-	@echo "# root.  Do NOT run \"make run-server\" server as root if you did #"
-	@echo "# not also unpack and compile it as root.                       #"
-	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server

=== modified file 'NEWS'
--- NEWS	2009-10-25 19:16:56 +0000
+++ NEWS	2009-05-23 05:59:52 +0000
@@ -1,31 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.0.14 (2009-10-25)
-Enable building without -pie and -fPIE if BROKEN_PIE is set.
-
-Version 1.0.13 (2009-10-22)
-* Client
-** Security bug fix: If Mandos server is also installed, do not copy
-   its config files (with encrypted passwords) into the initrd.img-*
-   files.
-
-Version 1.0.12 (2009-09-17)
-* Client
-** Bug fix: Allow network interface renaming by "udev" by taking down
-   the network interface after using it.
-** Bug fix: User-supplied plugins are now installed correctly.
-** Bug fix: If usplash was used but the password was instead provided
-   by the Mandos server, the usplash daemon used to ignore the first
-   command passed to it.  This has been fixed.
-** Bug fix: Make the "--userid" and "--groupid" options in
-   "plugin-runner.conf" work.
-* Server
-** Bug fix: Fix the LSB header in the init.d script to make dependency
-   based booting work.
-** A client receiving its password now also counts as if a checker was
-   run successfully (i.e. the timeout timer is reset).
-
 Version 1.0.11 (2009-05-23)
 * Client
 ** Bug fix: Use "pkg-config" instead of old "libgnutls-config".

=== modified file 'TODO'
--- TODO	2009-09-17 11:47:22 +0000
+++ TODO	2009-06-02 11:09:07 +0000
@@ -1,27 +1,7 @@
 -*- org -*-
 
 * mandos-client
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with argv[0]
-** TODO [#B] Retry a server which has a non-definite reply:
-*** A closed connection during the TLS handshake
-*** A TCP timeout
-** TODO [#B] Use capabilities instead of seteuid().
-
-* splashy
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
-
-* usplash
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
-
-* askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
-** TODO [#B] Drop privileges after opening FIFO.
-
-* password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#A] Clean up /tmp directory and take down interface on signal
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -45,12 +25,9 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Date+time on console log messages	:BUGS:
    Is this the default?
+** TODO Split IPv6_TCPServer into a generic and Mandos-specific class
+** TODO move handle_ipc out of IPv6_TCPServer
 ** TODO DBusServiceObjectUsingSuper
-** Global enable/disable flag
-** By-client countdown on secrets given
-** Fix problem with fsck taking a really long time
-   Whenever a client successfully gets a secret it could get a
-   one-time timeout boost to allow for an fsck-incurred delay
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
@@ -61,9 +38,10 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 
-* mandos-monitor
+* mandos-name
 ** D-Bus mail loop w/ signal receiver
-** Snack/Newt client data displayer
+** Urwid/Newt client data displayer
+*** Urwid scaffolding
 *** Client Widgets
 *** Properties popup
 
@@ -74,10 +52,6 @@
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
-* Makefile
-** Implement DEB_BUILD_OPTIONS
-   http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
-
 * Package
 ** /usr/share/initramfs-tools/hooks/mandos
 *** TODO [#C] use same file name rules as run-parts(8)

=== modified file 'common.ent'
--- common.ent	2009-10-25 19:16:56 +0000
+++ common.ent	2009-05-23 05:59:52 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.0.14">
+<!ENTITY version "1.0.11">

=== modified file 'debian/changelog'
--- debian/changelog	2009-10-25 19:16:56 +0000
+++ debian/changelog	2009-05-23 05:59:52 +0000
@@ -1,34 +1,3 @@
-mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
-
-  * New upstream release.
-  * debian/rules: Build with BROKEN_PIE set on mips and mipsel
-    architectures - fixes FTBFS there.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 25 Oct 2009 20:10:09 +0100
-
-mandos (1.0.13-1) unstable; urgency=high
-
-  * New upstream release.
-  * Do not copy unnecessary files to initrd (Closes: #551907)
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 22 Oct 2009 00:53:21 +0200
-
-mandos (1.0.12-1) unstable; urgency=low
-
-  * New upstream release.
-  * init.d-mandos: Correct dependencies (Closes: #546928)
-  * debian/control (Standards-Version): Changed to "3.8.3".
-  * debian/mandos-client.README.Debian: Improved wording and formatting.
-    Updated location of nfsroot.txt.
-  * debian/mandos.README.Debian: Improved wording and formatting.
-  * debian/mandos-client.postinst (configure): Don't look for user and
-    group with the old name if upgrading from a new enough version.
-  * debian/mandos.postinst (configure): - '' -
-  * debian/mandos-client.README.Debian: Added text about non-usability of
-    pseudo-network interfaces.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 17 Sep 2009 15:03:59 +0200
-
 mandos (1.0.11-1) unstable; urgency=low
 
   * debian/control (Standards-Version): Changed to "3.8.1".

=== modified file 'debian/control'
--- debian/control	2009-09-17 11:47:22 +0000
+++ debian/control	2009-05-18 17:57:13 +0000
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Standards-Version: 3.8.3
+Standards-Version: 3.8.1
 Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
 Homepage: http://www.fukt.bsnet.se/mandos

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2009-09-08 06:28:20 +0000
+++ debian/mandos-client.README.Debian	2009-04-14 14:56:46 +0000
@@ -1,42 +1,32 @@
-* Choose the Client Network Interface
-  
-  You MUST make sure that the correct network interface is specified
-  in the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  *If* this is changed, it will be necessary to update the
-  initrd image by running the command
-  
-	update-initramfs -k all -u
-  
-  The device can be overridden at boot time on the Linux kernel
-  command line using the sixth colon-separated field of the "ip="
-  option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
-  available in the "linux-doc-*" package.
-  
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, a real interface (such as "eth0") must be used.
-
-* Adding a Client Password to the Server
-  
-  The server must be given a password to give back to the client on
-  boot time.  This password must be a one which can be used to unlock
-  the root file system device.  On the *client*, run this command:
-  
-	mandos-keygen --password
-  
-  It will prompt for a password and output a config file section.
-  This output should be copied to the Mandos server and added to the
-  file "/etc/mandos/clients.conf" there.
-
-* Testing that it Works (Without Rebooting)
-  
-  After the server has been started with this client's key added, it
-  is possible to verify that the correct password will be received by
+* Configure The Server
+  
+  A client key has been automatically created in /etc/keys/mandos.
+  The next step is to run "mandos-keygen --password" to get a config
+  file section.  This should be appended to /etc/mandos/clients.conf
+  on the Mandos server.
+
+* Use the Correct Network Interface
+  
+  Make sure that the correct network interface is specified in the
+  DEVICE setting in the "/etc/initramfs-tools/initramfs.conf" file.
+  If this is changed, it will be necessary to update the initrd image
+  by doing "update-initramfs -k all -u".  This setting can be
+  overridden at boot time on the Linux kernel command line using the
+  sixth colon-separated field of the "ip=" option; for exact syntax,
+  see the file "Documentation/nfsroot.txt" in the Linux source tree.
+  
+  Note that since this is used in the initial RAM disk environment,
+  the network interface must exist at that stage.  Thus, the interface
+  can *not* be a pseudo-interface such as "br0" or "tun0"; instead, a
+  real interface (such as "eth0") must be used.
+
+* Test the Server
+  
+  After the server has been started and this client's key added, it is
+  possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
-	/usr/lib/mandos/plugins.d/mandos-client \
+	# /usr/lib/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
 		--seckey=/etc/keys/mandos/seckey.txt; echo
   
@@ -46,16 +36,16 @@
 
 * User-Supplied Plugins
   
-  Any plugins found in "/etc/mandos/plugins.d" will override and add
-  to the normal Mandos plugins.  When adding or changing plugins, do
-  not forget to update the initital RAM disk image:
+  Any plugins found in /etc/mandos/plugins.d will override and add to
+  the normal Mandos plugins.  When adding or changing plugins, do not
+  forget to update the initital RAM disk image:
   
-	update-initramfs -k all -u
+	# update-initramfs -k all -u
 
-* Do *NOT* Edit "/etc/crypttab"
+* Do *NOT* Edit /etc/crypttab
   
-  It is NOT necessary to edit "/etc/crypttab" to specify
-  "/usr/lib/mandos/plugin-runner" as a keyscript for the root file
+  It is NOT necessary to edit /etc/crypttab to specify
+  /usr/lib/mandos/plugin-runner as a keyscript for the root file
   system; if no keyscript is given for the root file system, the
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
@@ -84,4 +74,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 08:25:58 +0200
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue, 14 Apr 2009 16:51:18 +0200

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2009-09-08 06:28:20 +0000
+++ debian/mandos.README.Debian	2009-01-04 22:15:01 +0000
@@ -1,10 +1,7 @@
 The Mandos server is useless without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and run the command
-
-	# mandos-keygen --password
-
-there to get a config file stanza.  Append the output of that command
-to the file "/etc/mandos/clients.conf" on the Mandos server.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 06:57:45 +0200
+package on a client computer, and run "mandos-keygen --password" there
+to get a config file stanza.  Append that to /etc/mandos/clients.conf
+on the Mandos server.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  4 Jan 2009 22:59:22 +0100

=== modified file 'debian/rules'
--- debian/rules	2009-10-25 19:06:56 +0000
+++ debian/rules	2009-01-18 00:18:50 +0000
@@ -15,15 +15,6 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
-ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-
 configure: configure-stamp
 configure-stamp:
 	dh_testdir

=== modified file 'init.d-mandos'
--- init.d-mandos	2009-09-16 23:28:39 +0000
+++ init.d-mandos	2008-09-21 12:04:02 +0000
@@ -1,8 +1,8 @@
 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides:          mandos
-# Required-Start:    $remote_fs $syslog avahi
-# Required-Stop:     $remote_fs $syslog avahi
+# Required-Start:    $remote_fs avahi-daemon
+# Required-Stop:     $remote_fs
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
 # Short-Description: Mandos server

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2009-10-21 22:48:02 +0000
+++ initramfs-tools-hook	2009-04-17 08:26:17 +0000
@@ -90,7 +90,8 @@
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
 	    : ;;
-	"*") echo "W: Mandos client plugin directory is empty." >&2 ;;
+	*/"*")
+	    echo "W: Mandos client plugin directory is empty." >&2 ;;
 	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done
@@ -101,7 +102,7 @@
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
 	    : ;;
-	"*") : ;;
+	*/"*") : ;;
 	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done
@@ -114,7 +115,7 @@
 fi
 
 # Config files
-for file in /etc/mandos/plugin-runner.conf; do
+for file in /etc/mandos/*; do
     if [ -d "$file" ]; then
 	continue
     fi

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-09-16 23:28:39 +0000
+++ initramfs-tools-script	2009-02-09 02:01:13 +0000
@@ -10,6 +10,7 @@
 # eventually be "/scripts/init-premount/mandos" in the initrd.img
 # file.
 
+# No initramfs pre-requirements.
 PREREQ="udev"
 prereqs()
 {

=== modified file 'mandos'
--- mandos	2009-10-25 19:16:56 +0000
+++ mandos	2009-07-12 20:15:29 +0000
@@ -77,7 +77,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.0.14"
+version = "1.0.11"
 
 logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -812,7 +812,7 @@
                     break
             else:
                 ipc.write(u"NOTFOUND %s %s\n"
-                          % (fpr, unicode(self.client_address)))
+                          % (fpr, unicode(self.client_address))
                 session.bye()
                 return
             # Have to check if client.still_valid(), since it is
@@ -901,7 +901,7 @@
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
-        This function creates a new pipe in self.pipe
+        This function creates a new pipe in self.pipe 
         """
         self.pipe = os.pipe()
         super(ForkingMixInWithPipe,
@@ -1196,8 +1196,8 @@
                       help=u"Directory to search for configuration"
                       u" files")
     parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+                      dest=u"use_dbus", help=u"Do not provide D-Bus"
+                      u" system bus interface")
     parser.add_option("--no-ipv6", action=u"store_false",
                       dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
@@ -1255,7 +1255,6 @@
     # For convenience
     debug = server_settings[u"debug"]
     use_dbus = server_settings[u"use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     use_ipv6 = server_settings[u"use_ipv6"]
     
     if not debug:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2009-09-17 01:21:27 +0000
+++ mandos-clients.conf.xml	2009-02-15 09:09:27 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2009-09-17">
+<!ENTITY TIMESTAMP "2009-02-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -108,11 +108,10 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait (for either a
-	    successful checker run or a client receiving its secret)
-	    until a client is considered invalid - that is, ineligible
-	    to get the data this server holds.  By default Mandos will
-	    use 1 hour.
+	    The timeout is how long the server will wait for a
+	    successful checker run until a client is considered
+	    invalid - that is, ineligible to get the data this server
+	    holds.  By default Mandos will use 1 hour.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-10-25 19:16:56 +0000
+++ mandos-ctl	2009-05-23 05:59:52 +0000
@@ -31,7 +31,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.14"
+version = "1.0.11"
 bus = dbus.SystemBus()
 mandos_dbus_objc = bus.get_object(busname, server_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -106,7 +106,7 @@
                                       for client in
                                       clients))
                               for key in keywords)
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print format_string % tuple(tablewords[key] for key in keywords) 
     for client in clients:
         print format_string % tuple(valuetostring(client[key], key)
                                     for key in keywords)

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-10-25 19:16:56 +0000
+++ mandos-keygen	2009-05-23 05:59:52 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.14"
+VERSION="1.0.11"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-10-25 19:16:56 +0000
+++ mandos.lsm	2009-05-23 05:59:52 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.14
-Entered-date:	2009-10-25
+Version:	1.0.11
+Entered-date:	2009-05-23
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      103K mandos_1.0.14.orig.tar.gz
+	      99K mandos_1.0.11.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		103K mandos_1.0.14.orig.tar.gz
+		99K mandos_1.0.11.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2009-09-17 11:47:22 +0000
+++ mandos.xml	2009-02-25 01:47:45 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-09-17">
+<!ENTITY TIMESTAMP "2009-02-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -86,6 +86,8 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
+      <arg><option>--no-dbus</option></arg>
+      <sbr/>
       <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -233,6 +235,16 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--no-dbus</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
+	  <para>
+	    See also <xref linkend="dbus_interface"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--no-ipv6</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
@@ -315,14 +327,11 @@
       The server will, by default, continually check that the clients
       are still up.  If a client has not been confirmed as being up
       for some time, the client is assumed to be compromised and is no
-      longer eligible to receive the encrypted password.  (Manual
-      intervention is required to re-enable a client.)  The timeout,
+      longer eligible to receive the encrypted password.  The timeout,
       checker program, and interval between checks can be configured
       both globally and per client; see <citerefentry>
       <refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.  A client successfully
-      receiving its password will also be treated as a successful
-      checker run.
+      <manvolnum>5</manvolnum></citerefentry>.
     </para>
   </refsect1>
   
@@ -336,6 +345,16 @@
     </para>
   </refsect1>
   
+  <refsect1 id="dbus_interface">
+    <title>D-BUS INTERFACE</title>
+    <para>
+      The server will by default provide a D-Bus system bus interface.
+      This interface will only be accessible by the root user or a
+      Mandos-specific user, if such a user exists.
+      <!-- XXX -->
+    </para>
+  </refsect1>
+  
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-09-10 06:28:14 +0000
+++ plugin-runner.c	2009-02-12 19:08:35 +0000
@@ -1,4 +1,4 @@
-/*  -*- coding: utf-8; mode: c; mode: orgtbl -*- */
+/*  -*- coding: utf-8 -*- */
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
@@ -38,8 +38,7 @@
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG(),
-				   WCOREDUMP() */
+				   WEXITSTATUS() */
 #include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
 #include <dirent.h>		/* DIR, struct dirent, opendir(),
@@ -53,8 +52,7 @@
 				   close() */
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
 				   FD_CLOEXEC */
-#include <string.h>		/* strsep, strlen(), asprintf(),
-				   strsignal() */
+#include <string.h>		/* strsep, strlen(), asprintf() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -110,18 +108,13 @@
     }
   }
   /* Create a new plugin */
-  plugin *new_plugin = NULL;
-  do {
-    new_plugin = malloc(sizeof(plugin));
-  } while(new_plugin == NULL and errno == EINTR);
+  plugin *new_plugin = malloc(sizeof(plugin));
   if(new_plugin == NULL){
     return NULL;
   }
   char *copy_name = NULL;
   if(name != NULL){
-    do {
-      copy_name = strdup(name);
-    } while(copy_name == NULL and errno == EINTR);
+    copy_name = strdup(name);
     if(copy_name == NULL){
       free(new_plugin);
       return NULL;
@@ -133,9 +126,7 @@
 			  .disabled = false,
 			  .next = plugin_list };
   
-  do {
-    new_plugin->argv = malloc(sizeof(char *) * 2);
-  } while(new_plugin->argv == NULL and errno == EINTR);
+  new_plugin->argv = malloc(sizeof(char *) * 2);
   if(new_plugin->argv == NULL){
     free(copy_name);
     free(new_plugin);
@@ -144,9 +135,7 @@
   new_plugin->argv[0] = copy_name;
   new_plugin->argv[1] = NULL;
   
-  do {
-    new_plugin->environ = malloc(sizeof(char *));
-  } while(new_plugin->environ == NULL and errno == EINTR);
+  new_plugin->environ = malloc(sizeof(char *));
   if(new_plugin->environ == NULL){
     free(copy_name);
     free(new_plugin->argv);
@@ -164,19 +153,14 @@
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
-  do {
-    *array = realloc(*array, sizeof(char *)
-		     * (size_t) ((*len) + 2));
-  } while(*array == NULL and errno == EINTR);
+  *array = realloc(*array, sizeof(char *)
+		   * (size_t) ((*len) + 2));
   /* Malloc check */
   if(*array == NULL){
     return false;
   }
   /* Make a copy of the new string */
-  char *copy;
-  do {
-    copy = strdup(new);
-  } while(copy == NULL and errno == EINTR);
+  char *copy = strdup(new);
   if(copy == NULL){
     return false;
   }
@@ -208,10 +192,7 @@
     if(strncmp(*e, def, namelen + 1) == 0){
       /* It already exists */
       if(replace){
-	char *new;
-	do {
-	  new = realloc(*e, strlen(def) + 1);
-	} while(new == NULL and errno == EINTR);
+	char *new = realloc(*e, strlen(def) + 1);
 	if(new == NULL){
 	  return false;
 	}
@@ -227,17 +208,16 @@
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
- | [[info:libc:Descriptor%20Flags][File Descriptor Flags]] |
+ * *Note File Descriptor Flags:(libc)Descriptor Flags.
  */
 static int set_cloexec_flag(int fd){
-  int ret = (int)TEMP_FAILURE_RETRY(fcntl(fd, F_GETFD, 0));
+  int ret = fcntl(fd, F_GETFD, 0);
   /* If reading the flags failed, return error indication now. */
   if(ret < 0){
     return ret;
   }
   /* Store modified flag word in the descriptor. */
-  return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
-				       ret | FD_CLOEXEC));
+  return fcntl(fd, F_SETFD, ret | FD_CLOEXEC);
 }
 
 
@@ -335,6 +315,7 @@
   fd_set rfds_all;
   int ret, maxfd = 0;
   ssize_t sret;
+  intmax_t tmpmax;
   uid_t uid = 65534;
   gid_t gid = 65534;
   bool debug = false;
@@ -399,9 +380,8 @@
   
   error_t parse_opt(int key, char *arg, __attribute__((unused))
 		    struct argp_state *state){
+    char *tmp;
     switch(key){
-      char *tmp;
-      intmax_t tmpmax;
     case 'g': 			/* --global-options */
       if(arg != NULL){
 	char *plugin_option;
@@ -477,7 +457,7 @@
       plugindir = strdup(arg);
       if(plugindir == NULL){
 	perror("strdup");
-      }
+      }      
       break;
     case 129:			/* --config-file */
       /* This is already done by parse_opt_config_file() */
@@ -547,7 +527,7 @@
       if(argfile == NULL){
 	perror("strdup");
       }
-      break;
+      break;      
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
@@ -582,7 +562,7 @@
     conffp = fopen(AFILE, "r");
   } else {
     conffp = fopen(argfile, "r");
-  }
+  }  
   if(conffp != NULL){
     char *org_line = NULL;
     char *p, *arg, *new_arg, *line;
@@ -632,17 +612,9 @@
 	  goto fallback;
 	}
 	custom_argv[custom_argc-1] = new_arg;
-	custom_argv[custom_argc] = NULL;
+	custom_argv[custom_argc] = NULL;	
       }
     }
-    do {
-      ret = fclose(conffp);
-    } while(ret == EOF and errno == EINTR);
-    if(ret == EOF){
-      perror("fclose");
-      exitstatus = EXIT_FAILURE;
-      goto fallback;
-    }
     free(org_line);
   } else {
     /* Check for harmful errors and go to fallback. Other errors might
@@ -727,9 +699,7 @@
   
   /* Read and execute any executable in the plugin directory*/
   while(true){
-    do {
-      dirst = readdir(dir);
-    } while(dirst == NULL and errno == EINTR);
+    dirst = readdir(dir);
     
     /* All directory entries have been processed */
     if(dirst == NULL){
@@ -789,19 +759,16 @@
     
     char *filename;
     if(plugindir == NULL){
-      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, PDIR "/%s",
-					     dirst->d_name));
+      ret = asprintf(&filename, PDIR "/%s", dirst->d_name);
     } else {
-      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, "%s/%s",
-					     plugindir,
-					     dirst->d_name));
+      ret = asprintf(&filename, "%s/%s", plugindir, dirst->d_name);
     }
     if(ret < 0){
       perror("asprintf");
       continue;
     }
     
-    ret = (int)TEMP_FAILURE_RETRY(stat(filename, &st));
+    ret = stat(filename, &st);
     if(ret == -1){
       perror("stat");
       free(filename);
@@ -809,8 +776,7 @@
     }
     
     /* Ignore non-executable files */
-    if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(access(filename, X_OK)) != 0)){
+    if(not S_ISREG(st.st_mode) or (access(filename, X_OK) != 0)){
       if(debug){
 	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
 		" with bad type or mode\n", filename);
@@ -862,7 +828,7 @@
     }
     
     int pipefd[2];
-    ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
+    ret = pipe(pipefd);
     if(ret == -1){
       perror("pipe");
       exitstatus = EXIT_FAILURE;
@@ -882,19 +848,14 @@
       goto fallback;
     }
     /* Block SIGCHLD until process is safely in process list */
-    ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
-					      &sigchld_action.sa_mask,
-					      NULL));
+    ret = sigprocmask(SIG_BLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     /* Starting a new process to be watched */
-    pid_t pid;
-    do {
-      pid = fork();
-    } while(pid == -1 and errno == EINTR);
+    pid_t pid = fork();
     if(pid == -1){
       perror("fork");
       exitstatus = EXIT_FAILURE;
@@ -938,15 +899,12 @@
       /* no return */
     }
     /* Parent process */
-    TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
-					     pipe */
+    close(pipefd[1]);		/* Close unused write end of pipe */
     free(filename);
     plugin *new_plugin = getplugin(dirst->d_name);
     if(new_plugin == NULL){
       perror("getplugin");
-      ret = (int)(TEMP_FAILURE_RETRY
-		  (sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask,
-			       NULL)));
+      ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
         perror("sigprocmask");
       }
@@ -959,9 +917,7 @@
     
     /* Unblock SIGCHLD so signal handler can be run if this process
        has already completed */
-    ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
-					      &sigchld_action.sa_mask,
-					      NULL));
+    ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
@@ -975,7 +931,7 @@
     }
   }
   
-  TEMP_FAILURE_RETRY(closedir(dir));
+  closedir(dir);
   dir = NULL;
   free_plugin(getplugin(NULL));
   
@@ -994,7 +950,7 @@
   while(plugin_list){
     fd_set rfds = rfds_all;
     int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-    if(select_ret == -1 and errno != EINTR){
+    if(select_ret == -1){
       perror("select");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -1017,10 +973,9 @@
 		      WEXITSTATUS(proc->status));
 	    } else if(WIFSIGNALED(proc->status)){
 	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] killed by"
-		      " signal %d: %s\n", proc->name,
+		      " signal %d\n", proc->name,
 		      (intmax_t) (proc->pid),
-		      WTERMSIG(proc->status),
-		      strsignal(WTERMSIG(proc->status)));
+		      WTERMSIG(proc->status));
 	    } else if(WCOREDUMP(proc->status)){
 	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] dumped"
 		      " core\n", proc->name, (intmax_t) (proc->pid));
@@ -1031,10 +986,7 @@
 	  FD_CLR(proc->fd, &rfds_all);
 	  
 	  /* Block signal while modifying process_list */
-	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
-					(SIG_BLOCK,
-					 &sigchld_action.sa_mask,
-					 NULL));
+	  ret = sigprocmask(SIG_BLOCK, &sigchld_action.sa_mask, NULL);
 	  if(ret < 0){
 	    perror("sigprocmask");
 	    exitstatus = EXIT_FAILURE;
@@ -1046,9 +998,8 @@
 	  proc = next_plugin;
 	  
 	  /* We are done modifying process list, so unblock signal */
-	  ret = (int)(TEMP_FAILURE_RETRY
-		      (sigprocmask(SIG_UNBLOCK,
-				   &sigchld_action.sa_mask, NULL)));
+	  ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask,
+			    NULL);
 	  if(ret < 0){
 	    perror("sigprocmask");
 	    exitstatus = EXIT_FAILURE;
@@ -1091,10 +1042,8 @@
 	proc->buffer_size += BUFFER_SIZE;
       }
       /* Read from the process */
-      sret = TEMP_FAILURE_RETRY(read(proc->fd,
-				     proc->buffer
-				     + proc->buffer_length,
-				     BUFFER_SIZE));
+      sret = read(proc->fd, proc->buffer + proc->buffer_length,
+		  BUFFER_SIZE);
       if(sret < 0){
 	/* Read error from this process; ignore the error */
 	proc = proc->next;
@@ -1162,7 +1111,7 @@
   }
   
   /* Wait for any remaining child processes to terminate */
-  do {
+  do{
     ret = wait(NULL);
   } while(ret >= 0);
   if(errno != ECHILD){

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2009-09-16 23:28:39 +0000
+++ plugins.d/askpass-fifo.c	2009-01-10 06:00:50 +0000
@@ -19,7 +19,8 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
+ * <https://www.fukt.bsnet.se/~teddy/>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
@@ -28,7 +29,7 @@
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EEXIST */
 #include <stdio.h>		/* perror() */
-#include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
+#include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(), 
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
 #include <unistd.h>		/* read(), close(), write(),
@@ -42,14 +43,14 @@
   
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
-  ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
+  ret = (int)TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
   if(ret == -1 and errno != EEXIST){
     perror("mkfifo");
     return EXIT_FAILURE;
   }
   
   /* Open FIFO */
-  int fifo_fd = open(passfifo, O_RDONLY);
+  int fifo_fd = (int)TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
   if(fifo_fd == -1){
     perror("open");
     return EXIT_FAILURE;
@@ -61,7 +62,7 @@
   {
     size_t buf_allocated = 0;
     const size_t blocksize = 1024;
-    do {
+    do{
       if(buf_len + blocksize > buf_allocated){
 	char *tmp = realloc(buf, buf_allocated + blocksize);
 	if(tmp == NULL){
@@ -72,23 +73,25 @@
 	buf = tmp;
 	buf_allocated += blocksize;
       }
-      sret = read(fifo_fd, buf + buf_len, buf_allocated - buf_len);
+      sret = TEMP_FAILURE_RETRY(read(fifo_fd, buf + buf_len,
+				     buf_allocated - buf_len));
       if(sret == -1){
 	perror("read");
 	free(buf);
 	return EXIT_FAILURE;
       }
       buf_len += (size_t)sret;
-    } while(sret != 0);
+    }while(sret != 0);
   }
   
   /* Close FIFO */
-  close(fifo_fd);
+  TEMP_FAILURE_RETRY(close(fifo_fd));
   
   /* Print password to stdout */
   size_t written = 0;
   while(written < buf_len){
-    sret = write(STDOUT_FILENO, buf + written, buf_len - written);
+    sret = TEMP_FAILURE_RETRY(write(STDOUT_FILENO, buf + written,
+				    buf_len - written));
     if(sret == -1){
       perror("write");
       free(buf);

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-09-17 11:22:28 +0000
+++ plugins.d/mandos-client.c	2009-06-02 11:09:07 +0000
@@ -44,7 +44,7 @@
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
-				   srand(), strtof(), abort() */
+				   srand(), strtof() */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h>		/* memset(), strcmp(), strlen(),
 				   strerror(), asprintf(), strcpy() */
@@ -71,8 +71,8 @@
 				   INET_ADDRSTRLEN, INET6_ADDRSTRLEN
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
-				   getuid(), getgid(), seteuid(),
-				   setgid(), pause() */
+				   getuid(), getgid(), setuid(),
+				   setgid() */
 #include <arpa/inet.h>		/* inet_pton(), htons */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -80,8 +80,8 @@
 				   argp_parse(), ARGP_KEY_ARG,
 				   ARGP_KEY_END, ARGP_ERR_UNKNOWN */
 #include <signal.h>		/* sigemptyset(), sigaddset(),
-				   sigaction(), SIGTERM, sig_atomic_t,
-				   raise() */
+				   sigaction(), SIGTERM, sigaction,
+				   sig_atomic_t */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -142,9 +142,6 @@
 		      .dh_bits = 1024, .priority = "SECURE256"
 		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
 
-sig_atomic_t quit_now = 0;
-int signal_received = 0;
-
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
@@ -167,6 +164,7 @@
  */
 static bool init_gpgme(const char *seckey,
 		       const char *pubkey, const char *tempdir){
+  int ret;
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -175,7 +173,6 @@
    * Helper function to insert pub and seckey to the engine keyring.
    */
   bool import_key(const char *filename){
-    int ret;
     int fd;
     gpgme_data_t pgp_data;
     
@@ -252,7 +249,7 @@
     return false;
   }
   
-  return true;
+  return true; 
 }
 
 /* 
@@ -477,12 +474,7 @@
 static int init_gnutls_session(gnutls_session_t *session){
   int ret;
   /* GnuTLS session creation */
-  do {
-    ret = gnutls_init(session, GNUTLS_SERVER);
-    if(quit_now){
-      return -1;
-    }
-  } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
+  ret = gnutls_init(session, GNUTLS_SERVER);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
@@ -490,13 +482,7 @@
   
   {
     const char *err;
-    do {
-      ret = gnutls_priority_set_direct(*session, mc.priority, &err);
-      if(quit_now){
-	gnutls_deinit(*session);
-	return -1;
-      }
-    } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
+    ret = gnutls_priority_set_direct(*session, mc.priority, &err);
     if(ret != GNUTLS_E_SUCCESS){
       fprintf(stderr, "Syntax error at: %s\n", err);
       fprintf(stderr, "GnuTLS error: %s\n",
@@ -506,14 +492,8 @@
     }
   }
   
-  do {
-    ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
-				 mc.cred);
-    if(quit_now){
-      gnutls_deinit(*session);
-      return -1;
-    }
-  } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
+  ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
+			       mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
 	    safer_gnutls_strerror(ret));
@@ -522,7 +502,8 @@
   }
   
   /* ignore client certificate if any. */
-  gnutls_certificate_server_set_request(*session, GNUTLS_CERT_IGNORE);
+  gnutls_certificate_server_set_request(*session,
+					GNUTLS_CERT_IGNORE);
   
   gnutls_dh_set_prime_bits(*session, mc.dh_bits);
   
@@ -537,25 +518,22 @@
 static int start_mandos_communication(const char *ip, uint16_t port,
 				      AvahiIfIndex if_index,
 				      int af){
-  int ret, tcp_sd = -1;
+  int ret, tcp_sd;
   ssize_t sret;
   union {
     struct sockaddr_in in;
     struct sockaddr_in6 in6;
   } to;
   char *buffer = NULL;
-  char *decrypted_buffer = NULL;
+  char *decrypted_buffer;
   size_t buffer_length = 0;
   size_t buffer_capacity = 0;
+  ssize_t decrypted_buffer_size;
   size_t written;
-  int retval = -1;
+  int retval = 0;
   gnutls_session_t session;
   int pf;			/* Protocol family */
   
-  if(quit_now){
-    return -1;
-  }
-  
   switch(af){
   case AF_INET6:
     pf = PF_INET6;
@@ -581,11 +559,7 @@
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
     perror("socket");
-    goto mandos_end;
-  }
-  
-  if(quit_now){
-    goto mandos_end;
+    return -1;
   }
   
   memset(&to, 0, sizeof(to));
@@ -598,11 +572,11 @@
   }
   if(ret < 0 ){
     perror("inet_pton");
-    goto mandos_end;
+    return -1;
   }
   if(ret == 0){
     fprintf(stderr, "Bad address: %s\n", ip);
-    goto mandos_end;
+    return -1;
   }
   if(af == AF_INET6){
     to.in6.sin6_port = htons(port); /* Spurious warnings from
@@ -615,7 +589,7 @@
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf(stderr, "An IPv6 link-local address is incomplete"
 		" without a network interface\n");
-	goto mandos_end;
+	return -1;
       }
       /* Set the network interface number as scope */
       to.in6.sin6_scope_id = (uint32_t)if_index;
@@ -626,10 +600,6 @@
 				     -Wunreachable-code */
   }
   
-  if(quit_now){
-    goto mandos_end;
-  }
-  
   if(debug){
     if(af == AF_INET6 and if_index != AVAHI_IF_UNSPEC){
       char interface[IF_NAMESIZE];
@@ -662,10 +632,6 @@
     }
   }
   
-  if(quit_now){
-    goto mandos_end;
-  }
-  
   if(af == AF_INET6){
     ret = connect(tcp_sd, &to.in6, sizeof(to));
   } else {
@@ -673,11 +639,7 @@
   }
   if(ret < 0){
     perror("connect");
-    goto mandos_end;
-  }
-  
-  if(quit_now){
-    goto mandos_end;
+    return -1;
   }
   
   const char *out = mandos_protocol_version;
@@ -688,6 +650,7 @@
 				   out_size - written));
     if(ret == -1){
       perror("write");
+      retval = -1;
       goto mandos_end;
     }
     written += (size_t)ret;
@@ -701,31 +664,16 @@
 	break;
       }
     }
-  
-    if(quit_now){
-      goto mandos_end;
-    }
   }
   
   if(debug){
     fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
-  if(quit_now){
-    goto mandos_end;
-  }
-  
   gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
-  if(quit_now){
-    goto mandos_end;
-  }
-  
-  do {
+  do{
     ret = gnutls_handshake(session);
-    if(quit_now){
-      goto mandos_end;
-    }
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
   
   if(ret != GNUTLS_E_SUCCESS){
@@ -733,6 +681,7 @@
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
+    retval = -1;
     goto mandos_end;
   }
   
@@ -744,19 +693,11 @@
   }
   
   while(true){
-    
-    if(quit_now){
-      goto mandos_end;
-    }
-    
     buffer_capacity = incbuffer(&buffer, buffer_length,
 				   buffer_capacity);
     if(buffer_capacity == 0){
       perror("incbuffer");
-      goto mandos_end;
-    }
-    
-    if(quit_now){
+      retval = -1;
       goto mandos_end;
     }
     
@@ -771,22 +712,20 @@
       case GNUTLS_E_AGAIN:
 	break;
       case GNUTLS_E_REHANDSHAKE:
-	do {
+	do{
 	  ret = gnutls_handshake(session);
-	  
-	  if(quit_now){
-	    goto mandos_end;
-	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
+	  retval = -1;
 	  goto mandos_end;
 	}
 	break;
       default:
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
+	retval = -1;
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	goto mandos_end;
       }
@@ -799,30 +738,15 @@
     fprintf(stderr, "Closing TLS session\n");
   }
   
-  if(quit_now){
-    goto mandos_end;
-  }
-  
-  do {
-    ret = gnutls_bye(session, GNUTLS_SHUT_RDWR);
-    if(quit_now){
-      goto mandos_end;
-    }
-  } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
+  gnutls_bye(session, GNUTLS_SHUT_RDWR);
   
   if(buffer_length > 0){
-    ssize_t decrypted_buffer_size;
     decrypted_buffer_size = pgp_packet_decrypt(buffer,
 					       buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
-      
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
-	if(quit_now){
-	  goto mandos_end;
-	}
-	
 	ret = (int)fwrite(decrypted_buffer + written, 1,
 			  (size_t)decrypted_buffer_size - written,
 			  stdout);
@@ -831,29 +755,28 @@
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
-	  goto mandos_end;
+	  retval = -1;
+	  break;
 	}
 	written += (size_t)ret;
       }
-      retval = 0;
+      free(decrypted_buffer);
+    } else {
+      retval = -1;
     }
+  } else {
+    retval = -1;
   }
   
   /* Shutdown procedure */
   
  mandos_end:
-  free(decrypted_buffer);
   free(buffer);
-  if(tcp_sd >= 0){
-    ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
-  }
+  ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
   if(ret == -1){
     perror("close");
   }
   gnutls_deinit(session);
-  if(quit_now){
-    retval = -1;
-  }
   return retval;
 }
 
@@ -876,10 +799,6 @@
   /* Called whenever a service has been resolved successfully or
      timed out */
   
-  if(quit_now){
-    return;
-  }
-  
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
@@ -922,10 +841,6 @@
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
   
-  if(quit_now){
-    return;
-  }
-  
   switch(event){
   default:
   case AVAHI_BROWSER_FAILURE:
@@ -960,13 +875,14 @@
   }
 }
 
+sig_atomic_t quit_now = 0;
+
 /* stop main loop after sigterm has been called */
-static void handle_sigterm(int sig){
+static void handle_sigterm(__attribute__((unused)) int sig){
   if(quit_now){
     return;
   }
   quit_now = 1;
-  signal_received = sig;
   int old_errno = errno;
   if(mc.simple_poll != NULL){
     avahi_simple_poll_quit(mc.simple_poll);
@@ -984,7 +900,7 @@
   const char *interface = "eth0";
   struct ifreq network;
   int sd = -1;
-  bool take_down_interface = false;
+  bool interface_taken_up = false;
   uid_t uid;
   gid_t gid;
   char *connect_to = NULL;
@@ -998,30 +914,9 @@
   bool gpgme_initialized = false;
   float delay = 2.5f;
   
-  struct sigaction old_sigterm_action = { .sa_handler = SIG_DFL };
+  struct sigaction old_sigterm_action;
   struct sigaction sigterm_action = { .sa_handler = handle_sigterm };
   
-  uid = getuid();
-  gid = getgid();
-  
-  /* Lower any group privileges we might have, just to be safe */
-  errno = 0;
-  ret = setgid(gid);
-  if(ret == -1){
-    perror("setgid");
-  }
-  
-  /* Lower user privileges (temporarily) */
-  errno = 0;
-  ret = seteuid(uid);
-  if(ret == -1){
-    perror("seteuid");
-  }
-  
-  if(quit_now){
-    goto end;
-  }
-  
   {
     struct argp_option options[] = {
       { .name = "debug", .key = 128,
@@ -1154,70 +1049,15 @@
     exitcode = EXIT_FAILURE;
     goto end;
   }
-  /* Need to check if the handler is SIG_IGN before handling:
-     | [[info:libc:Initial Signal Actions]] |
-     | [[info:libc:Basic Signal Handling]]  |
-  */
-  ret = sigaction(SIGINT, NULL, &old_sigterm_action);
-  if(ret == -1){
-    perror("sigaction");
-    return EXIT_FAILURE;
-  }
-  if(old_sigterm_action.sa_handler != SIG_IGN){
-    ret = sigaction(SIGINT, &sigterm_action, NULL);
-    if(ret == -1){
-      perror("sigaction");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
-  ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
-  if(ret == -1){
-    perror("sigaction");
-    return EXIT_FAILURE;
-  }
-  if(old_sigterm_action.sa_handler != SIG_IGN){
-    ret = sigaction(SIGHUP, &sigterm_action, NULL);
-    if(ret == -1){
-      perror("sigaction");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
-  ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
-  if(ret == -1){
-    perror("sigaction");
-    return EXIT_FAILURE;
-  }
-  if(old_sigterm_action.sa_handler != SIG_IGN){
-    ret = sigaction(SIGTERM, &sigterm_action, NULL);
-    if(ret == -1){
-      perror("sigaction");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
+  ret = sigaction(SIGTERM, &sigterm_action, &old_sigterm_action);
+  if(ret == -1){
+    perror("sigaction");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }  
   
   /* If the interface is down, bring it up */
   if(interface[0] != '\0'){
-    if_index = (AvahiIfIndex) if_nametoindex(interface);
-    if(if_index == 0){
-      fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-    
-    if(quit_now){
-      goto end;
-    }
-    
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
-    if(ret == -1){
-      perror("seteuid");
-    }
-    
 #ifdef __linux__
     /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
        messages to mess up the prompt */
@@ -1241,12 +1081,6 @@
 	}
       }
 #endif	/* __linux__ */
-      /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
       goto end;
     }
     strcpy(network.ifr_name, interface);
@@ -1262,20 +1096,12 @@
       }
 #endif	/* __linux__ */
       exitcode = EXIT_FAILURE;
-      /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
       goto end;
     }
     if((network.ifr_flags & IFF_UP) == 0){
       network.ifr_flags |= IFF_UP;
-      take_down_interface = true;
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
-	take_down_interface = false;
 	perror("ioctl SIOCSIFFLAGS");
 	exitcode = EXIT_FAILURE;
 #ifdef __linux__
@@ -1286,14 +1112,9 @@
 	  }
 	}
 #endif	/* __linux__ */
-	/* Lower privileges */
-	errno = 0;
-	ret = seteuid(uid);
-	if(ret == -1){
-	  perror("seteuid");
-	}
 	goto end;
       }
+      interface_taken_up = true;
     }
     /* sleep checking until interface is running */
     for(int i=0; i < delay * 4; i++){
@@ -1309,8 +1130,7 @@
 	perror("nanosleep");
       }
     }
-    if(not take_down_interface){
-      /* We won't need the socket anymore */
+    if(not interface_taken_up){
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
 	perror("close");
@@ -1325,25 +1145,20 @@
       }
     }
 #endif	/* __linux__ */
-    /* Lower privileges */
-    errno = 0;
-    if(take_down_interface){
-      /* Lower privileges */
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
-    } else {
-      /* Lower privileges permanently */
-      ret = setuid(uid);
-      if(ret == -1){
-	perror("setuid");
-      }
-    }
-  }
-  
-  if(quit_now){
-    goto end;
+  }
+  
+  uid = getuid();
+  gid = getgid();
+  
+  errno = 0;
+  setgid(gid);
+  if(ret == -1){
+    perror("setgid");
+  }
+  
+  ret = setuid(uid);
+  if(ret == -1){
+    perror("setuid");
   }
   
   ret = init_gnutls_global(pubkey, seckey);
@@ -1355,20 +1170,11 @@
     gnutls_initialized = true;
   }
   
-  if(quit_now){
-    goto end;
-  }
-  
-  tempdir_created = true;
   if(mkdtemp(tempdir) == NULL){
-    tempdir_created = false;
     perror("mkdtemp");
     goto end;
   }
-  
-  if(quit_now){
-    goto end;
-  }
+  tempdir_created = true;
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
     fprintf(stderr, "init_gpgme failed\n");
@@ -1378,8 +1184,13 @@
     gpgme_initialized = true;
   }
   
-  if(quit_now){
-    goto end;
+  if(interface[0] != '\0'){
+    if_index = (AvahiIfIndex) if_nametoindex(interface);
+    if(if_index == 0){
+      fprintf(stderr, "No such interface: \"%s\"\n", interface);
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
   }
   
   if(connect_to != NULL){
@@ -1391,11 +1202,6 @@
       exitcode = EXIT_FAILURE;
       goto end;
     }
-    
-    if(quit_now){
-      goto end;
-    }
-    
     uint16_t port;
     errno = 0;
     tmpmax = strtoimax(address+1, &tmp, 10);
@@ -1405,11 +1211,6 @@
       exitcode = EXIT_FAILURE;
       goto end;
     }
-  
-    if(quit_now){
-      goto end;
-    }
-    
     port = (uint16_t)tmpmax;
     *address = '\0';
     address = connect_to;
@@ -1420,11 +1221,6 @@
     } else {
       af = AF_INET;
     }
-    
-    if(quit_now){
-      goto end;
-    }
-    
     ret = start_mandos_communication(address, port, if_index, af);
     if(ret < 0){
       exitcode = EXIT_FAILURE;
@@ -1433,11 +1229,7 @@
     }
     goto end;
   }
-  
-  if(quit_now){
-    goto end;
-  }
-  
+    
   {
     AvahiServerConfig config;
     /* Do not publish any local Zeroconf records */
@@ -1464,10 +1256,6 @@
     goto end;
   }
   
-  if(quit_now){
-    goto end;
-  }
-  
   /* Create the Avahi service browser */
   sb = avahi_s_service_browser_new(mc.server, if_index,
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
@@ -1479,10 +1267,6 @@
     goto end;
   }
   
-  if(quit_now){
-    goto end;
-  }
-  
   /* Run the main loop */
   
   if(debug){
@@ -1518,34 +1302,20 @@
   }
   
   /* Take down the network interface */
-  if(take_down_interface){
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
+  if(interface_taken_up){
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
     if(ret == -1){
-      perror("seteuid");
+      perror("ioctl SIOCGIFFLAGS");
+    } else if(network.ifr_flags & IFF_UP) {
+      network.ifr_flags &= ~IFF_UP; /* clear flag */
+      ret = ioctl(sd, SIOCSIFFLAGS, &network);
+      if(ret == -1){
+	perror("ioctl SIOCSIFFLAGS");
+      }
     }
-    if(geteuid() == 0){
-      ret = ioctl(sd, SIOCGIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP) {
-	network.ifr_flags &= ~IFF_UP; /* clear flag */
-	ret = ioctl(sd, SIOCSIFFLAGS, &network);
-	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS");
-	}
-      }
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror("close");
-      }
-      /* Lower privileges permanently */
-      errno = 0;
-      ret = setuid(uid);
-      if(ret == -1){
-	perror("setuid");
-      }
+    ret = (int)TEMP_FAILURE_RETRY(close(sd));
+    if(ret == -1){
+      perror("close");
     }
   }
   
@@ -1593,24 +1363,5 @@
     }
   }
   
-  if(quit_now){
-    sigemptyset(&old_sigterm_action.sa_mask);
-    old_sigterm_action.sa_handler = SIG_DFL;
-    ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
-					    &old_sigterm_action,
-					    NULL));
-    if(ret == -1){
-      perror("sigaction");
-    }
-    do {
-      ret = raise(signal_received);
-    } while(ret != 0 and errno == EINTR);
-    if(ret != 0){
-      perror("raise");
-      abort();
-    }
-    TEMP_FAILURE_RETRY(pause());
-  }
-  
   return exitcode;
 }

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-09-07 07:48:59 +0000
+++ plugins.d/password-prompt.c	2009-02-05 02:33:05 +0000
@@ -1,4 +1,4 @@
-/*  -*- coding: utf-8; mode: c; mode: orgtbl -*- */
+/*  -*- coding: utf-8 -*- */
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
@@ -19,7 +19,8 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
+ * <https://www.fukt.bsnet.se/~teddy/>.
  */
 
 #define _GNU_SOURCE		/* getline() */
@@ -32,8 +33,7 @@
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
-				   SIGQUIT, SIGHUP, SIGTERM,
-				   raise() */
+				   SIGQUIT, SIGHUP, SIGTERM */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <sys/types.h>		/* ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
@@ -52,17 +52,12 @@
 				   ARGP_ERR_UNKNOWN */
 
 volatile sig_atomic_t quit_now = 0;
-int signal_received;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-static void termination_handler(int signum){
-  if(quit_now){
-    return;
-  }
+static void termination_handler(__attribute__((unused))int signum){
   quit_now = 1;
-  signal_received = signum;
 }
 
 int main(int argc, char **argv){
@@ -128,25 +123,9 @@
   }
   
   sigemptyset(&new_action.sa_mask);
-  ret = sigaddset(&new_action.sa_mask, SIGINT);
-  if(ret == -1){
-    perror("sigaddset");
-    return EXIT_FAILURE;
-  }
-  ret = sigaddset(&new_action.sa_mask, SIGHUP);
-  if(ret == -1){
-    perror("sigaddset");
-    return EXIT_FAILURE;
-  }
-  ret = sigaddset(&new_action.sa_mask, SIGTERM);
-  if(ret == -1){
-    perror("sigaddset");
-    return EXIT_FAILURE;
-  }
-  /* Need to check if the handler is SIG_IGN before handling:
-     | [[info:libc:Initial Signal Actions]] |
-     | [[info:libc:Basic Signal Handling]]  |
-  */
+  sigaddset(&new_action.sa_mask, SIGINT);
+  sigaddset(&new_action.sa_mask, SIGHUP);
+  sigaddset(&new_action.sa_mask, SIGTERM);
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
@@ -215,7 +194,7 @@
       const char *cryptsource = getenv("cryptsource");
       const char *crypttarget = getenv("crypttarget");
       const char *const prompt
-	= "Enter passphrase to unlock the disk";
+	= "Enter passphrase to unlock the disk";      
       if(cryptsource == NULL){
 	if(crypttarget == NULL){
 	  fprintf(stderr, "%s: ", prompt);
@@ -263,7 +242,7 @@
     /* if(ret == 0), then the only sensible thing to do is to retry to
        read from stdin */
     fputc('\n', stderr);
-    if(debug and not quit_now){
+    if(debug and quit_now == 0){
       /* If quit_now is nonzero, we were interrupted by a signal, and
 	 will print that later, so no need to show this too. */
       fprintf(stderr, "getline() returned 0, retrying.\n");
@@ -279,16 +258,6 @@
     perror("tcsetattr+echo");
   }
   
-  if(quit_now){
-    sigemptyset(&old_action.sa_mask);
-    old_action.sa_handler = SIG_DFL;
-    ret = sigaction(signal_received, &old_action, NULL);
-    if(ret == -1){
-      perror("sigaction");
-    }
-    raise(signal_received);
-  }
-  
   if(debug){
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2009-09-16 23:28:39 +0000
+++ plugins.d/splashy.c	2009-02-12 18:56:52 +0000
@@ -19,10 +19,11 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
+ * <https://www.fukt.bsnet.se/~teddy/>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
+#define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
 				   SIGHUP, SIGTERM, sigaction,
@@ -40,33 +41,24 @@
 #include <iso646.h>		/* not, or, and */
 #include <unistd.h>		/* readlink(), fork(), execl(),
 				   sleep(), dup2() STDERR_FILENO,
-				   STDOUT_FILENO, _exit(),
-				   pause() */
+				   STDOUT_FILENO, _exit() */
 #include <string.h>		/* memcmp() */
 #include <errno.h>		/* errno */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS() */
 
 sig_atomic_t interrupted_by_signal = 0;
-int signal_received;
 
-static void termination_handler(int signum){
-  if(interrupted_by_signal){
-    return;
-  }
+static void termination_handler(__attribute__((unused))int signum){
   interrupted_by_signal = 1;
-  signal_received = signum;
 }
 
 int main(__attribute__((unused))int argc,
 	 __attribute__((unused))char **argv){
   int ret = 0;
+  
+  /* Create prompt string */
   char *prompt = NULL;
-  DIR *proc_dir = NULL;
-  pid_t splashy_pid = 0;
-  pid_t splashy_command_pid = 0;
-  
-  /* Create prompt string */
   {
     const char *const cryptsource = getenv("cryptsource");
     const char *const crypttarget = getenv("crypttarget");
@@ -89,18 +81,19 @@
       }
     }
     if(ret == -1){
-      prompt = NULL;
-      goto failure;
+      return EXIT_FAILURE;
     }
   }
   
   /* Find splashy process */
+  pid_t splashy_pid = 0;
   {
     const char splashy_name[] = "/sbin/splashy";
-    proc_dir = opendir("/proc");
+    DIR *proc_dir = opendir("/proc");
     if(proc_dir == NULL){
+      free(prompt);
       perror("opendir");
-      goto failure;
+      return EXIT_FAILURE;
     }
     for(struct dirent *proc_ent = readdir(proc_dir);
 	proc_ent != NULL;
@@ -127,7 +120,9 @@
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
 	  perror("asprintf");
-	  goto failure;
+	  free(prompt);
+	  closedir(proc_dir);
+	  return EXIT_FAILURE;
 	}
 	
 	/* Check that it refers to a symlink owned by root:root */
@@ -140,7 +135,9 @@
 	  }
 	  perror("lstat");
 	  free(exe_link);
-	  goto failure;
+	  free(prompt);
+	  closedir(proc_dir);
+	  return EXIT_FAILURE;
 	}
 	if(not S_ISLNK(exe_stat.st_mode)
 	   or exe_stat.st_uid != 0
@@ -160,10 +157,10 @@
       }
     }
     closedir(proc_dir);
-    proc_dir = NULL;
   }
   if(splashy_pid == 0){
-    goto failure;
+    free(prompt);
+    return EXIT_FAILURE;
   }
   
   /* Set up the signal handler */
@@ -172,180 +169,135 @@
       new_action = { .sa_handler = termination_handler,
 		     .sa_flags = 0 };
     sigemptyset(&new_action.sa_mask);
-    ret = sigaddset(&new_action.sa_mask, SIGINT);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
-    ret = sigaddset(&new_action.sa_mask, SIGHUP);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
-    ret = sigaddset(&new_action.sa_mask, SIGTERM);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
+    sigaddset(&new_action.sa_mask, SIGINT);
+    sigaddset(&new_action.sa_mask, SIGHUP);
+    sigaddset(&new_action.sa_mask, SIGTERM);
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
-      goto failure;
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
-	goto failure;
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
-      goto failure;
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
-	goto failure;
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
-      goto failure;
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
-	goto failure;
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
   }
   
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
   /* Fork off the splashy command to prompt for password */
-  splashy_command_pid = fork();
-  if(splashy_command_pid != 0 and interrupted_by_signal){
-    goto failure;
-  }
-  if(splashy_command_pid == -1){
-    perror("fork");
-    goto failure;
-  }
-  /* Child */
-  if(splashy_command_pid == 0){
-    if(not interrupted_by_signal){
+  pid_t splashy_command_pid = 0;
+  if(not interrupted_by_signal){
+    splashy_command_pid = fork();
+    if(splashy_command_pid == -1){
+      if(not interrupted_by_signal){
+	perror("fork");
+      }
+      return EXIT_FAILURE;
+    }
+    /* Child */
+    if(splashy_command_pid == 0){
       const char splashy_command[] = "/sbin/splashy_update";
-      execl(splashy_command, splashy_command, prompt, (char *)NULL);
-      perror("execl");
+      ret = execl(splashy_command, splashy_command, prompt,
+		  (char *)NULL);
+      if(not interrupted_by_signal){
+	perror("execl");
+      }
+      free(prompt);
+      _exit(EXIT_FAILURE);
     }
-    free(prompt);
-    _exit(EXIT_FAILURE);
   }
   
   /* Parent */
   free(prompt);
-  prompt = NULL;
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
   
   /* Wait for command to complete */
-  {
+  if(not interrupted_by_signal and splashy_command_pid != 0){
     int status;
-    do {
-      ret = waitpid(splashy_command_pid, &status, 0);
-    } while(ret == -1 and errno == EINTR
-	    and not interrupted_by_signal);
-    if(interrupted_by_signal){
-      goto failure;
-    }
+    ret = waitpid(splashy_command_pid, &status, 0);
     if(ret == -1){
-      perror("waitpid");
+      if(errno != EINTR){
+	perror("waitpid");
+      }
       if(errno == ECHILD){
 	splashy_command_pid = 0;
       }
     } else {
       /* The child process has exited */
       splashy_command_pid = 0;
-      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
+      if(not interrupted_by_signal and WIFEXITED(status)
+	 and WEXITSTATUS(status)==0){
 	return EXIT_SUCCESS;
       }
     }
   }
-  
- failure:
-  
-  free(prompt);
-  
-  if(proc_dir != NULL){
-    TEMP_FAILURE_RETRY(closedir(proc_dir));
-  }
-  
-  if(splashy_command_pid != 0){
-    TEMP_FAILURE_RETRY(kill(splashy_command_pid, SIGTERM));
-    
-    TEMP_FAILURE_RETRY(kill(splashy_pid, SIGTERM));
-    sleep(2);
-    while(TEMP_FAILURE_RETRY(kill(splashy_pid, 0)) == 0){
-      TEMP_FAILURE_RETRY(kill(splashy_pid, SIGKILL));
-      sleep(1);
-    }
-    pid_t new_splashy_pid = (pid_t)TEMP_FAILURE_RETRY(fork());
-    if(new_splashy_pid == 0){
-      /* Child; will become new splashy process */
-      
-      /* Make the effective user ID (root) the only user ID instead of
-	 the real user ID (_mandos) */
-      ret = setuid(geteuid());
-      if(ret == -1){
-	perror("setuid");
-      }
-      
-      setsid();
-      ret = chdir("/");
-      if(ret == -1){
-	perror("chdir");
-      }
-/*       if(fork() != 0){ */
-/* 	_exit(EXIT_SUCCESS); */
-/*       } */
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
-      if(ret == -1){
-	perror("dup2");
-	_exit(EXIT_FAILURE);
-      }
-    
-      execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
+  kill(splashy_pid, SIGTERM);
+  if(interrupted_by_signal and splashy_command_pid != 0){
+    kill(splashy_command_pid, SIGTERM);
+  }
+  sleep(2);
+  while(kill(splashy_pid, 0) == 0){
+    kill(splashy_pid, SIGKILL);
+    sleep(1);
+  }
+  pid_t new_splashy_pid = fork();
+  if(new_splashy_pid == 0){
+    /* Child; will become new splashy process */
+    
+    /* Make the effective user ID (root) the only user ID instead of
+       the real user ID (_mandos) */
+    ret = setuid(geteuid());
+    if(ret == -1){
+      perror("setuid");
+    }
+    
+    setsid();
+    ret = chdir("/");
+/*     if(fork() != 0){ */
+/*       _exit(EXIT_SUCCESS); */
+/*     } */
+    ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
+    if(ret == -1){
+      perror("dup2");
+      _exit(EXIT_FAILURE);
+    }
+    
+    execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
+    if(not interrupted_by_signal){
       perror("execl");
-      _exit(EXIT_FAILURE);
-    }
-  }
-  
-  if(interrupted_by_signal){
-    struct sigaction signal_action;
-    sigemptyset(&signal_action.sa_mask);
-    signal_action.sa_handler = SIG_DFL;
-    ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
-					    &signal_action, NULL));
-    if(ret == -1){
-      perror("sigaction");
-    }
-    do {
-      ret = raise(signal_received);
-    } while(ret != 0 and errno == EINTR);
-    if(ret != 0){
-      perror("raise");
-      abort();
-    }
-    TEMP_FAILURE_RETRY(pause());
+    }
+    _exit(EXIT_FAILURE);
   }
   
   return EXIT_FAILURE;

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2009-09-17 04:16:32 +0000
+++ plugins.d/usplash.c	2009-02-12 18:56:52 +0000
@@ -19,10 +19,11 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
+ * <https://www.fukt.bsnet.se/~teddy/>.
  */
 
-#define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
+#define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
 				   SIGHUP, SIGTERM, sigaction(),
@@ -49,266 +50,242 @@
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 
 sig_atomic_t interrupted_by_signal = 0;
-int signal_received;
-const char usplash_name[] = "/sbin/usplash";
 
-static void termination_handler(int signum){
-  if(interrupted_by_signal){
-    return;
-  }
+static void termination_handler(__attribute__((unused))int signum){
   interrupted_by_signal = 1;
-  signal_received = signum;
 }
 
-static bool usplash_write(int *fifo_fd_r,
-			  const char *cmd, const char *arg){
+static bool usplash_write(const char *cmd, const char *arg){
   /* 
-   * usplash_write(&fd, "TIMEOUT", "15") will write "TIMEOUT 15\0"
-   * usplash_write(&fd, "PULSATE", NULL) will write "PULSATE\0"
+   * usplash_write("TIMEOUT", "15") will write "TIMEOUT 15\0"
+   * usplash_write("PULSATE", NULL) will write "PULSATE\0"
    * SEE ALSO
    *         usplash_write(8)
    */
   int ret;
-  if(*fifo_fd_r == -1){
-    ret = open("/dev/.initramfs/usplash_fifo", O_WRONLY);
-    if(ret == -1){
+  int fifo_fd;
+  do{
+    fifo_fd = open("/dev/.initramfs/usplash_fifo", O_WRONLY);
+    if(fifo_fd == -1 and (errno != EINTR or interrupted_by_signal)){
       return false;
     }
-    *fifo_fd_r = ret;
-  }
+  }while(fifo_fd == -1);
   
   const char *cmd_line;
   size_t cmd_line_len;
   char *cmd_line_alloc = NULL;
   if(arg == NULL){
     cmd_line = cmd;
-    cmd_line_len = strlen(cmd) + 1;
-  } else {
-    do {
+    cmd_line_len = strlen(cmd);
+  }else{
+    do{
       ret = asprintf(&cmd_line_alloc, "%s %s", cmd, arg);
-      if(ret == -1){
+      if(ret == -1 and (errno != EINTR or interrupted_by_signal)){
 	int e = errno;
-	TEMP_FAILURE_RETRY(close(*fifo_fd_r));
+	close(fifo_fd);
 	errno = e;
 	return false;
       }
-    } while(ret == -1);
+    }while(ret == -1);
     cmd_line = cmd_line_alloc;
     cmd_line_len = (size_t)ret + 1;
   }
   
   size_t written = 0;
   ssize_t sret = 0;
-  while(written < cmd_line_len){
-    sret = write(*fifo_fd_r, cmd_line + written,
+  while(not interrupted_by_signal and written < cmd_line_len){
+    sret = write(fifo_fd, cmd_line + written,
 		 cmd_line_len - written);
     if(sret == -1){
-      int e = errno;
-      TEMP_FAILURE_RETRY(close(*fifo_fd_r));
-      free(cmd_line_alloc);
-      errno = e;
-      return false;
+      if(errno != EINTR or interrupted_by_signal){
+	int e = errno;
+	close(fifo_fd);
+	free(cmd_line_alloc);
+	errno = e;
+	return false;
+      } else {
+	continue;
+      }
     }
     written += (size_t)sret;
   }
   free(cmd_line_alloc);
-  
+  do{
+    ret = close(fifo_fd);
+    if(ret == -1 and (errno != EINTR or interrupted_by_signal)){
+      return false;
+    }
+  }while(ret == -1);
+  if(interrupted_by_signal){
+    return false;
+  }
   return true;
 }
 
-/* Create prompt string */
-char *makeprompt(void){
-  int ret = 0;
-  char *prompt;
-  const char *const cryptsource = getenv("cryptsource");
-  const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Enter passphrase to unlock the disk";
-  
-  if(cryptsource == NULL){
-    if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s: ", prompt_start);
-    } else {
-      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		     crypttarget);
-    }
-  } else {
-    if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
-    } else {
-      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		     cryptsource, crypttarget);
-    }
-  }
-  if(ret == -1){
-    return NULL;
-  }
-  return prompt;
-}
-
-pid_t find_usplash(char **cmdline_r, size_t *cmdline_len_r){
-  int ret = 0;
-  ssize_t sret = 0;
+int main(__attribute__((unused))int argc,
+	 __attribute__((unused))char **argv){
+  int ret = 0;
+  ssize_t sret;
+  bool an_error_occured = false;
+  
+  /* Create prompt string */
+  char *prompt = NULL;
+  {
+    const char *const cryptsource = getenv("cryptsource");
+    const char *const crypttarget = getenv("crypttarget");
+    const char prompt_start[] = "Enter passphrase to unlock the disk";
+    
+    if(cryptsource == NULL){
+      if(crypttarget == NULL){
+	ret = asprintf(&prompt, "%s: ", prompt_start);
+      } else {
+	ret = asprintf(&prompt, "%s (%s): ", prompt_start,
+		       crypttarget);
+      }
+    } else {
+      if(crypttarget == NULL){
+	ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
+      } else {
+	ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
+		       cryptsource, crypttarget);
+      }
+    }
+    if(ret == -1){
+      return EXIT_FAILURE;
+    }
+  }
+  
+  /* Find usplash process */
+  pid_t usplash_pid = 0;
   char *cmdline = NULL;
   size_t cmdline_len = 0;
-  DIR *proc_dir = opendir("/proc");
-  if(proc_dir == NULL){
-    perror("opendir");
-    return -1;
-  }
-  errno = 0;
-  for(struct dirent *proc_ent = readdir(proc_dir);
-      proc_ent != NULL;
-      proc_ent = readdir(proc_dir)){
-    pid_t pid;
-    {
-      intmax_t tmpmax;
-      char *tmp;
-      tmpmax = strtoimax(proc_ent->d_name, &tmp, 10);
-      if(errno != 0 or tmp == proc_ent->d_name or *tmp != '\0'
-	 or tmpmax != (pid_t)tmpmax){
-	/* Not a process */
+  const char usplash_name[] = "/sbin/usplash";
+  {
+    DIR *proc_dir = opendir("/proc");
+    if(proc_dir == NULL){
+      free(prompt);
+      perror("opendir");
+      return EXIT_FAILURE;
+    }
+    for(struct dirent *proc_ent = readdir(proc_dir);
+	proc_ent != NULL;
+	proc_ent = readdir(proc_dir)){
+      pid_t pid;
+      {
+	intmax_t tmpmax;
+	char *tmp;
 	errno = 0;
-	continue;
-      }
-      pid = (pid_t)tmpmax;
-    }
-    /* Find the executable name by doing readlink() on the
-       /proc/<pid>/exe link */
-    char exe_target[sizeof(usplash_name)];
-    {
-      /* create file name string */
-      char *exe_link;
-      ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
-      if(ret == -1){
-	perror("asprintf");
-	goto fail_find_usplash;
-      }
-      
-      /* Check that it refers to a symlink owned by root:root */
-      struct stat exe_stat;
-      ret = lstat(exe_link, &exe_stat);
-      if(ret == -1){
-	if(errno == ENOENT){
-	  free(exe_link);
+	tmpmax = strtoimax(proc_ent->d_name, &tmp, 10);
+	if(errno != 0 or tmp == proc_ent->d_name or *tmp != '\0'
+	   or tmpmax != (pid_t)tmpmax){
+	  /* Not a process */
 	  continue;
 	}
-	perror("lstat");
-	free(exe_link);
-	goto fail_find_usplash;
-      }
-      if(not S_ISLNK(exe_stat.st_mode)
-	 or exe_stat.st_uid != 0
-	 or exe_stat.st_gid != 0){
-	free(exe_link);
-	continue;
-      }
-	
-      sret = readlink(exe_link, exe_target, sizeof(exe_target));
-      free(exe_link);
-    }
-    /* Compare executable name */
-    if((sret != ((ssize_t)sizeof(exe_target)-1))
-       or (memcmp(usplash_name, exe_target,
-		  sizeof(exe_target)-1) != 0)){
-      /* Not it */
-      continue;
-    }
-    /* Found usplash */
-    /* Read and save the command line of usplash in "cmdline" */
-    {
-      /* Open /proc/<pid>/cmdline  */
-      int cl_fd;
+	pid = (pid_t)tmpmax;
+      }
+      /* Find the executable name by doing readlink() on the
+	 /proc/<pid>/exe link */
+      char exe_target[sizeof(usplash_name)];
       {
-	char *cmdline_filename;
-	ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
-		       proc_ent->d_name);
+	/* create file name string */
+	char *exe_link;
+	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
 	  perror("asprintf");
-	  goto fail_find_usplash;
-	}
-	cl_fd = open(cmdline_filename, O_RDONLY);
-	free(cmdline_filename);
-	if(cl_fd == -1){
-	  perror("open");
-	  goto fail_find_usplash;
-	}
+	  free(prompt);
+	  closedir(proc_dir);
+	  return EXIT_FAILURE;
+	}
+	
+	/* Check that it refers to a symlink owned by root:root */
+	struct stat exe_stat;
+	ret = lstat(exe_link, &exe_stat);
+	if(ret == -1){
+	  if(errno == ENOENT){
+	    free(exe_link);
+	    continue;
+	  }
+	  perror("lstat");
+	  free(exe_link);
+	  free(prompt);
+	  closedir(proc_dir);
+	  return EXIT_FAILURE;
+	}
+	if(not S_ISLNK(exe_stat.st_mode)
+	   or exe_stat.st_uid != 0
+	   or exe_stat.st_gid != 0){
+	  free(exe_link);
+	  continue;
+	}
+	
+	sret = readlink(exe_link, exe_target, sizeof(exe_target));
+	free(exe_link);
       }
-      size_t cmdline_allocated = 0;
-      char *tmp;
-      const size_t blocksize = 1024;
-      do {
-	/* Allocate more space? */
-	if(cmdline_len + blocksize > cmdline_allocated){
-	  tmp = realloc(cmdline, cmdline_allocated + blocksize);
-	  if(tmp == NULL){
-	    perror("realloc");
-	    close(cl_fd);
-	    goto fail_find_usplash;
+      if((sret == ((ssize_t)sizeof(exe_target)-1))
+	 and (memcmp(usplash_name, exe_target,
+		     sizeof(exe_target)-1) == 0)){
+	usplash_pid = pid;
+	/* Read and save the command line of usplash in "cmdline" */
+	{
+	  /* Open /proc/<pid>/cmdline  */
+	  int cl_fd;
+	  {
+	    char *cmdline_filename;
+	    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+			   proc_ent->d_name);
+	    if(ret == -1){
+	      perror("asprintf");
+	      free(prompt);
+	      closedir(proc_dir);
+	      return EXIT_FAILURE;
+	    }
+	    cl_fd = open(cmdline_filename, O_RDONLY);
+	    if(cl_fd == -1){
+	      perror("open");
+	      free(cmdline_filename);
+	      free(prompt);
+	      closedir(proc_dir);
+	      return EXIT_FAILURE;
+	    }
+	    free(cmdline_filename);
 	  }
-	  cmdline = tmp;
-	  cmdline_allocated += blocksize;
-	}
-	/* Read data */
-	sret = read(cl_fd, cmdline + cmdline_len,
-		    cmdline_allocated - cmdline_len);
-	if(sret == -1){
-	  perror("read");
+	  size_t cmdline_allocated = 0;
+	  char *tmp;
+	  const size_t blocksize = 1024;
+	  do{
+	    if(cmdline_len + blocksize > cmdline_allocated){
+	      tmp = realloc(cmdline, cmdline_allocated + blocksize);
+	      if(tmp == NULL){
+		perror("realloc");
+		free(cmdline);
+		free(prompt);
+		closedir(proc_dir);
+		return EXIT_FAILURE;
+	      }
+	      cmdline = tmp;
+	      cmdline_allocated += blocksize;
+	    }
+	    sret = read(cl_fd, cmdline + cmdline_len,
+			cmdline_allocated - cmdline_len);
+	    if(sret == -1){
+	      perror("read");
+	      free(cmdline);
+	      free(prompt);
+	      closedir(proc_dir);
+	      return EXIT_FAILURE;
+	    }
+	    cmdline_len += (size_t)sret;
+	  } while(sret != 0);
 	  close(cl_fd);
-	  goto fail_find_usplash;
 	}
-	cmdline_len += (size_t)sret;
-      } while(sret != 0);
-      ret = close(cl_fd);
-      if(ret == -1){
-	perror("close");
-	goto fail_find_usplash;
+	break;
       }
     }
-    /* Close directory */
-    ret = closedir(proc_dir);
-    if(ret == -1){
-      perror("closedir");
-      goto fail_find_usplash;
-    }
-    /* Success */
-    *cmdline_r = cmdline;
-    *cmdline_len_r = cmdline_len;
-    return pid;
-  }
-  
- fail_find_usplash:
-  
-  free(cmdline);
-  if(proc_dir != NULL){
-    int e = errno;
     closedir(proc_dir);
-    errno = e;
-  }
-  return 0;
-}
-
-int main(__attribute__((unused))int argc,
-	 __attribute__((unused))char **argv){
-  int ret = 0;
-  ssize_t sret;
-  int fifo_fd = -1;
-  int outfifo_fd = -1;
-  char *buf = NULL;
-  size_t buf_len = 0;
-  pid_t usplash_pid = -1;
-  bool usplash_accessed = false;
-  
-  char *prompt = makeprompt();
-  if(prompt == NULL){
-    goto failure;
-  }
-  
-  /* Find usplash process */
-  char *cmdline = NULL;
-  size_t cmdline_len = 0;
-  usplash_pid = find_usplash(&cmdline, &cmdline_len);
+  }
   if(usplash_pid == 0){
-    goto failure;
+    free(prompt);
+    return EXIT_FAILURE;
   }
   
   /* Set up the signal handler */
@@ -317,231 +294,172 @@
       new_action = { .sa_handler = termination_handler,
 		     .sa_flags = 0 };
     sigemptyset(&new_action.sa_mask);
-    ret = sigaddset(&new_action.sa_mask, SIGINT);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
-    ret = sigaddset(&new_action.sa_mask, SIGHUP);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
-    ret = sigaddset(&new_action.sa_mask, SIGTERM);
-    if(ret == -1){
-      perror("sigaddset");
-      goto failure;
-    }
+    sigaddset(&new_action.sa_mask, SIGINT);
+    sigaddset(&new_action.sa_mask, SIGHUP);
+    sigaddset(&new_action.sa_mask, SIGTERM);
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
-      if(errno != EINTR){
-	perror("sigaction");
-      }
-      goto failure;
+      perror("sigaction");
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
-	if(errno != EINTR){
-	  perror("sigaction");
-	}
-	goto failure;
+	perror("sigaction");
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
-      if(errno != EINTR){
-	perror("sigaction");
-      }
-      goto failure;
+      perror("sigaction");
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
-	if(errno != EINTR){
-	  perror("sigaction");
-	}
-	goto failure;
+	perror("sigaction");
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
-      if(errno != EINTR){
-	perror("sigaction");
-      }
-      goto failure;
+      perror("sigaction");
+      free(prompt);
+      return EXIT_FAILURE;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
-	if(errno != EINTR){
-	  perror("sigaction");
-	}
-	goto failure;
+	perror("sigaction");
+	free(prompt);
+	return EXIT_FAILURE;
       }
     }
   }
   
-  usplash_accessed = true;
   /* Write command to FIFO */
-  if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
-    if(errno != EINTR){
-      perror("usplash_write");
-    }
-    goto failure;
-  }
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
-  if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
-    if(errno != EINTR){
-      perror("usplash_write");
-    }
-    goto failure;
-  }
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
+  if(not interrupted_by_signal){
+    if(not usplash_write("TIMEOUT", "0")
+       and (errno != EINTR)){
+      perror("usplash_write");
+      an_error_occured = true;
+    }
+  }
+  if(not interrupted_by_signal and not an_error_occured){
+    if(not usplash_write("INPUTQUIET", prompt)
+       and (errno != EINTR)){
+      perror("usplash_write");
+      an_error_occured = true;
+    }
+  }
   free(prompt);
-  prompt = NULL;
-  
-  /* Read reply from usplash */
-  /* Open FIFO */
-  outfifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
-  if(outfifo_fd == -1){
-    if(errno != EINTR){
-      perror("open");
-    }
-    goto failure;
-  }
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
-  /* Read from FIFO */
-  size_t buf_allocated = 0;
-  const size_t blocksize = 1024;
-  do {
-    /* Allocate more space */
-    if(buf_len + blocksize > buf_allocated){
-      char *tmp = realloc(buf, buf_allocated + blocksize);
-      if(tmp == NULL){
+  
+  /* This is not really a loop; while() is used to be able to "break"
+     out of it; those breaks are marked "Big" */
+  while(not interrupted_by_signal and not an_error_occured){
+    char *buf = NULL;
+    size_t buf_len = 0;
+    
+    /* Open FIFO */
+    int fifo_fd;
+    do{
+      fifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
+      if(fifo_fd == -1){
 	if(errno != EINTR){
+	  perror("open");
+	  an_error_occured = true;
+	  break;
+	}
+	if(interrupted_by_signal){
+	  break;
+	}
+      }
+    }while(fifo_fd == -1);
+    if(interrupted_by_signal or an_error_occured){
+      break;			/* Big */
+    }
+    
+    /* Read from FIFO */
+    size_t buf_allocated = 0;
+    const size_t blocksize = 1024;
+    do{
+      if(buf_len + blocksize > buf_allocated){
+	char *tmp = realloc(buf, buf_allocated + blocksize);
+	if(tmp == NULL){
 	  perror("realloc");
-	}
-	goto failure;
-      }
-      buf = tmp;
-      buf_allocated += blocksize;
-    }
-    sret = read(outfifo_fd, buf + buf_len,
-		buf_allocated - buf_len);
-    if(sret == -1){
-      if(errno != EINTR){
-	perror("read");
-      }
-      TEMP_FAILURE_RETRY(close(outfifo_fd));
-      goto failure;
-    }
-    if(interrupted_by_signal){
-      break;
-    }
-    
-    buf_len += (size_t)sret;
-  } while(sret != 0);
-  ret = close(outfifo_fd);
-  if(ret == -1){
-    if(errno != EINTR){
-      perror("close");
-    }
-    goto failure;
-  }
-  outfifo_fd = -1;
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
-  if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
-    if(errno != EINTR){
-      perror("usplash_write");
-    }
-    goto failure;
-  }
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
-  ret = close(fifo_fd);
-  if(ret == -1){
-    if(errno != EINTR){
-      perror("close");
-    }
-    goto failure;
-  }
-  fifo_fd = -1;
-  
-  /* Print password to stdout */
-  size_t written = 0;
-  while(written < buf_len){
-    do {
-      sret = write(STDOUT_FILENO, buf + written, buf_len - written);
-      if(sret == -1){
-	if(errno != EINTR){
-	  perror("write");
-	}
-	goto failure;
-      }
-    } while(sret == -1);
-    
-    if(interrupted_by_signal){
-      goto failure;
-    }
-    written += (size_t)sret;
-  }
-  free(buf);
-  buf = NULL;
-  
-  if(interrupted_by_signal){
-    goto failure;
-  }
-  
-  free(cmdline);
-  return EXIT_SUCCESS;
-  
- failure:
-  
-  free(buf);
-  
-  free(prompt);
-  
-  /* If usplash was never accessed, we can stop now */
-  if(not usplash_accessed){
-    return EXIT_FAILURE;
-  }
-  
-  /* Close FIFO */
-  if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
-    if(ret == -1 and errno != EINTR){
-      perror("close");
-    }
-    fifo_fd = -1;
-  }
-  
-  /* Close output FIFO */
-  if(outfifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(outfifo_fd));
-    if(ret == -1){
-      perror("close");
-    }
-  }
+	  an_error_occured = true;
+	  break;
+	}
+	buf = tmp;
+	buf_allocated += blocksize;
+      }
+      do{
+	sret = read(fifo_fd, buf + buf_len, buf_allocated - buf_len);
+	if(sret == -1){
+	  if(errno != EINTR){
+	    perror("read");
+	    an_error_occured = true;
+	    break;
+	  }
+	  if(interrupted_by_signal){
+	    break;
+	  }
+	}
+      }while(sret == -1);
+      if(interrupted_by_signal or an_error_occured){
+	break;
+      }
+      
+      buf_len += (size_t)sret;
+    }while(sret != 0);
+    close(fifo_fd);
+    if(interrupted_by_signal or an_error_occured){
+      break;			/* Big */
+    }
+    
+    if(not usplash_write("TIMEOUT", "15")
+       and (errno != EINTR)){
+	perror("usplash_write");
+	an_error_occured = true;
+    }
+    if(interrupted_by_signal or an_error_occured){
+      break;			/* Big */
+    }
+    
+    /* Print password to stdout */
+    size_t written = 0;
+    while(written < buf_len){
+      do{
+	sret = write(STDOUT_FILENO, buf + written, buf_len - written);
+	if(sret == -1){
+	  if(errno != EINTR){
+	    perror("write");
+	    an_error_occured = true;
+	    break;
+	  }
+	  if(interrupted_by_signal){
+	    break;
+	  }
+	}
+      }while(sret == -1);
+      if(interrupted_by_signal or an_error_occured){
+	break;
+      }
+      written += (size_t)sret;
+    }
+    free(buf);
+    if(not interrupted_by_signal and not an_error_occured){
+      free(cmdline);
+      return EXIT_SUCCESS;
+    }
+    break;			/* Big */
+  }				/* end of non-loop while() */
+  
+  /* If we got here, an error or interrupt must have happened */
   
   /* Create argc and argv for new usplash*/
   int cmdline_argc = 0;
@@ -571,7 +489,6 @@
     kill(usplash_pid, SIGKILL);
     sleep(1);
   }
-  
   pid_t new_usplash_pid = fork();
   if(new_usplash_pid == 0){
     /* Child; will become new usplash process */
@@ -605,37 +522,9 @@
   free(cmdline);
   free(cmdline_argv);
   sleep(2);
-  if(not usplash_write(&fifo_fd, "PULSATE", NULL)){
-    if(errno != EINTR){
-      perror("usplash_write");
-    }
-  }
-  
-  /* Close FIFO (again) */
-  if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
-    if(ret == -1 and errno != EINTR){
-      perror("close");
-    }
-    fifo_fd = -1;
-  }
-  
-  if(interrupted_by_signal){
-    struct sigaction signal_action = { .sa_handler = SIG_DFL };
-    sigemptyset(&signal_action.sa_mask);
-    ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
-					    &signal_action, NULL));
-    if(ret == -1){
-      perror("sigaction");
-    }
-    do {
-      ret = raise(signal_received);
-    } while(ret != 0 and errno == EINTR);
-    if(ret != 0){
-      perror("raise");
-      abort();
-    }
-    TEMP_FAILURE_RETRY(pause());
+  if(not usplash_write("PULSATE", NULL)
+     and (errno != EINTR)){
+    perror("usplash_write");
   }
   
   return EXIT_FAILURE;

